<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
class authentication
{
	function &factory()
	{
		global $config;
		$authSettings = $config['authentication'];
		if (!empty($authSettings['type']))
		{
			$driverPath = $config['base_dir'].'include/auth/'.$authSettings['type'].'.php';
			if (file_exists($driverPath))
			{
				include_once($driverPath);
				$driverObject = "authentication_$authSettings[type]";
				return new $driverObject();
			}
			else
			{
				$GLOBALS['logger']->log(lang("Error: Cannot find specified authentication driver ($authSettings[type]"));
				return false;
			}
		}
		else
		{
			$GLOBALS['logger']->log(lang('Configuration error: No authentication type defined'));
			return false;
		}
	}
	function isLoggedIn()
	{
		$authEnabled = $GLOBALS['config']['settings']['authentication']['enabled'];
		return !$authEnabled OR !empty($_SESSION['login']['authenticated']);
	}
	function check($loginPage, $redirect)
	{
		if (!authentication::isLoggedIn())
		{
			$_SESSION['login']['redirect'] = $redirect;
			common::redirect($loginPage);
		}
	}
}
?>