<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
class common
{
	function truncateText($text, $length, $postfix = '...')
	{
		if (strlen($text) > $length) $text = substr($text, 0, $length) . $postfix;
		return $text;
	}
	function errorMsg(&$errorMsg, $noError = '')
	{
		global $SESSION;
		if (!empty($_SESSION['common']['errorMsg']))
		{
			$errorMsg = $_SESSION['common']['errorMsg'];
			unset($_SESSION['common']['errorMsg']);
		}
		else $errorMsg = $noError;
	}
	function redirect($to, $error_msg = null)
	{
		if (!empty($error_msg)) $_SESSION['common']['errorMsg'] = $error_msg;
		header('Location: '.common::url($to));
		exit;
	}
	function url($file = null)
	{
		global $config;
		include_once($config['base_dir'].'include/pear/Net/URL.php');
		$url = new Net_URL($file);
		$url->addQueryString(session_name(), session_id());
		return $url->getURL();
	}
	function getClientIP()
	{
		global $_SERVER;
		static $ip_address;
		if (@!$ip_address)
		{
			$ip_address = !empty($_SERVER['CLIENT_IP']) ? $_SERVER['CLIENT_IP'] : '';
			$ip_address = !empty($_SERVER['HTTP_X_FORWARDED_FOR']) && empty($ip_address)? $_SERVER['HTTP_X_FORWARDED_FOR'] : $ip_address;
			$ip_address = !empty($_SERVER['REMOTE_ADDR']) && empty($ip_address)? $_SERVER['REMOTE_ADDR'] : $ip_address;
		}
		return $ip_address;
	}
	function errorHandler($level, $message, $file, $line)
	{
		if ((error_reporting() & $level) != $level) return;
		$fp = fopen($file, 'r');
		if ($fp)
		{
			for ($i=1; !feof($fp) AND $i<=($line + 5); ++$i)
			{
				if ($i >= ($line - 5))
				{
					$areaOfFile[] = "($i) " . fgets($fp, 1024);
					if ($i == $line) $areaOfFile[count($areaOfFile) - 1] = '<strong style="border: 1px solid black; background-color: white">' . $areaOfFile[count($areaOfFile) - 1] . "</strong>";
					fgets($fp, 1024);
				}
			}
			fclose($fp);
		}
		switch ($level)
		{
			case 1:
				$errorType = 'E_ERROR';
				break;
			case 2:
				$errorType = 'E_WARNING';
				break;
			case 4:
				$errorType = 'E_PARSE';
				break;
			case 8:
				$errorType = 'E_NOTICE';
				break;
			case 16:
				$errorType = 'E_CORE_ERROR';
				break;
			case 32:
				$errorType = 'E_CORE_WARNING';
				break;
			case 64:
				$errorType = 'E_COMPILE_ERROR';
				break;
			case 128:
				$errorType = 'E_COMPILE_WARNING';
				break;
			case 256:
				$errorType = 'E_USER_ERROR';
				break;
			case 512:
				$errorType = 'E_USER_WARNING';
				break;
			case 1024:
				$errorType = 'E_USER_NOTICE';
				break;
		}
?>
		<div style="background-color: #ffaaaa; border: 2px black dotted; margin: 5px; padding: 2px; font-family: monospace">
		<strong>
			Error:<br />
		</strong>
		<strong>Type.........:</strong> <?php echo $errorType ?><br />
		<strong>Message......:</strong> <?php echo $message ?><br />
		<strong>File.........:</strong> <?php echo $file ?><br />
		<strong>Area in File.:</strong> (<?php echo $line ?>) <?php echo implode("<br />\r\n.............: ", $areaOfFile)?>
		</div>
<?php
	}
	function getTemplate($template)
	{
		global $config;
		$templatesDir = $config['base_dir'].'themes/default'.DIRECTORY_SEPARATOR;
		if (file_exists($templatesDir.$template)) return $templatesDir.$template;
		else return false;
	}
	function stripslashes_r(&$input)
	{
		common::applyFunction($input, 'stripslashes');
	}
	function applyFunction(&$input, $function)
	{
		foreach ($input as $k => $v)
		{
			if (is_array($v)) common::applyFunction($input[$k], $function);
			else $input[$k] = $function($v);
		}
	}
	function formatFilesize($filesize)
	{
		if ($filesize >= 1073741824) return number_format($filesize / 1073741824, 1).'Gb';
		else if ($filesize >= 1048576) return number_format($filesize / 1048576, 1).'Mb';
		else if ($filesize >= 1024) return number_format($filesize / 1024, 1).'Kb';
		else return $filesize;
	}
}
?>