<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
require_once($config['base_dir'].'include/pear/Console/Table.php');
class table extends Console_Table
{
	var $_options;
	function table($options = array())
	{
		$this->Console_Table();
		$defaultOptions['tableAttributes'] = '';
		$defaultOptions['rowAttributes'] = '';
		$defaultOptions['cellAttributes'] = '';
		$defaultOptions['altRowAttributes'] = '';
		$defaultOptions['altCellAttributes'] = '';
		$defaultOptions['headRowAttributes'] = '';
		$defaultOptions['headCellAttributes'] = '';
		$this->_options = array_merge($defaultOptions, $options);
	}
	function _buildTable()
	{
		$return = array();
		$rows = $this->_data;
		$tableAttributes = $this->_options['tableAttributes'];
		$rowAttributes = $this->_options['rowAttributes'];
		$cellAttributes = $this->_options['cellAttributes'];
		$altRowAttributes = $this->_options['altRowAttributes'];
		$altCellAttributes = $this->_options['altCellAttributes'];
		$row_begin = "<tr $rowAttributes><td $cellAttributes>";
		$altRow_begin = "<tr $altRowAttributes><td $altCellAttributes>";
		$row_end = "</td></tr>";
		$implode_char = "</td><td $cellAttributes>";
		$altImplode_char = "</td><td $altCellAttributes>";
		for ($i=0; $i<count($rows); $i++)
		{
			for ($j=0; $j<count($rows[$i]); $j++)
			{
				if (strlen($rows[$i][$j]) < $this->_cell_lengths[$j]) $rows[$i][$j] = str_pad($rows[$i][$j], $this->_cell_lengths[$j], ' ');
			}
			if ($i % 2 == 1) $return[] = $altRow_begin.implode($altImplode_char, $rows[$i]).$row_end;
			else $return[] = $row_begin.implode($implode_char, $rows[$i]).$row_end;
		}
		$return = $this->_getSeparator()."\r\n".implode("\n", $return)."\r\n".$this->_getSeparator()."\r\n";
		if (!empty($this->_headers)) $return = $this->_getHeaderLine()."\r\n".$return;
		$return = "<table $tableAttributes>\r\n$return\r\n</table>";
		return $return;
	}
	function _getSeparator()
	{
		return '';
	}
	function _getHeaderLine()
	{
		for ($i=0; $i<$this->_max_cols; $i++)
		{
			if (!isset($this->_headers[$i])) $this->_headers[$i] = '';
		}
		for ($i=0; $i<count($this->_headers); $i++)
		{
			if (strlen($this->_headers[$i]) < $this->_cell_lengths[$i]) $this->_headers[$i] = $this->_headers[$i];
		}
		$headRowAttributes = $this->_options['headRowAttributes'];
		$headCellAttributes = $this->_options['headCellAttributes'];
		$row_begin = "<tr $headRowAttributes><th $headCellAttributes>";
		$row_end = "</th></tr>";
		$implode_char = "</th><th $headCellAttributes>";
		$return[] = $row_begin.implode($implode_char, $this->_headers).$row_end;
		return implode("\r\n", $return);
	}
}
?>