<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
include('conf.inc.php');
include($config['base_dir'].'include/prepend.php');
if (empty($_SESSION['database']['path'])) common::redirect('index.right.php', lang('No database is selected!'));
$DB = &database::singleton($_SESSION['database']['params']);
if (!empty($_GET['sql']))
{
	$sql = $origSql = trim($_GET['sql']);
	$identifier = '([a-z][a-z0-9_]*|\[[a-z][a-z0-9_]*\])';
	if (!preg_match('/\s+FROM\s+[a-z]/i', $sql) OR preg_match('/(NATURAL)?\s*(LEFT|RIGHT|FULL)?\s*(OUTER|INNER|CROSS)?\s*JOIN/i', $sql) OR preg_match("/\s+FROM\s+$identifier\s*,/i", $sql) OR preg_match('/^SELECT.+\(.+FROM/Ui', $sql)) $showEditDelete = false;
	else
	{
		preg_match("/\s+FROM\s+$identifier\s*/i", $sql, $matches);
		$tablename = $matches[1];
		$showEditDelete = ($tablename != 'sqlite_master' ? true : false);
	}
	if (!preg_match('/LIMIT\s+([0-9]+)(\s+OFFSET\s+([0-9])+)?$/i', $sql, $matches) AND preg_match('/^SELECT/i', $sql))
	{
		$sql .= ' LIMIT 30 OFFSET 0';
		$limitNumber = 30;
		$offsetNumber = 0;
	}
	else
	{
		$limitNumber = @$matches[1];
		$offsetNumber = @$matches[3];
	}
	if (preg_match('/^select /i', $sql) AND $showEditDelete) $sql = preg_replace('/^(select) /i', '$1 _ROWID_, ', $sql);
	$result = $DB->query($sql);
	$querySuccessful = is_object($result) OR $result;
	$queryHasResults = is_object($result) AND $result->numRows() > 0;
	if ($queryHasResults)
	{
		$resultsTable = array();
		$headers = array();
		while ($row = $result->fetchRow())
		{
			$resultsRow = array();
			if (empty($headers)) $headers = array_slice(array_keys($row), $showEditDelete ? 1 : 0);
			foreach ($row as $k => $v)
			{
				if ($k == '_ROWID_' AND empty($resultsRow) AND $showEditDelete) $resultsRow[] = sprintf('<nobr><a href="%s">%s</a> :: <a href="%s" onclick="return confirm(\'%s\')">%s</a></nobr>', common::url("row.php?action=edit&table=$tablename&rowid=$v&redirect=" . rawurlencode(common::url()) ), lang('Edit'), common::url("row.php?action=delete&table=$tablename&rowid=$v&redirect=" . rawurlencode(common::url())), lang('Are you sure you want to delete this row?'), lang('Delete'));
				else $resultsRow[] = $v;
			}
			$resultsTable[] = $resultsRow;
		}
	}
}
else if (!empty($_GET['table'])) $origSql = "SELECT * FROM $_GET[table]";
$template = 'query.tpl';
include($config['base_dir'].'include/template.php');
?>