<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
include('conf.inc.php');
include($config['base_dir'].'include/prepend.php');
function parseRowData($autoIncrement = null)
{
	global $DB;
	foreach ($_POST['rowData'] as $columnName => $columnValue)
	{
		if (!is_null($autoIncrement) AND $columnName == $autoIncrement) continue;
            if (!empty($_POST['null'][$columnName]))
		{
			$sqlFields = $columnName;
			$sqlValues = 'NULL';
		}
		else if (!empty($_POST['functions'][$columnName]))
		{
			list($functionType, $functionName) = explode(':', $_POST['functions'][$columnName]);
			if ($functionType == 'php') $columnValue = $DB->quote(call_user_func($functionName, $columnValue));
			else if ($functionType == 'sqlite')
			{
				if (sqlite::getNumArguments(strtolower($functionName)) == 0) $columnValue = "$functionName()";
				else
				{
					$columnValue = $DB->quote($columnValue);
					$columnValue = "$functionName($columnValue)";
				}
			}
            	$sqlFields[] = $columnName;
			$sqlValues[] = $columnValue;
		}
		else
		{
			$sqlFields[] = $columnName;
			$sqlValues[] = $DB->quote($_POST['rowData'][$columnName]);
		}
	}
	return array($sqlFields, $sqlValues);
}
if (empty($_GET['table'])) common::redirect('database.php', lang('No table given!'));
else $tableName = $_GET['table'];
if ($_GET['action'] != 'insert')
{
	if (empty($_GET['rowid'])) common::redirect("table.php?table=$tableName", lang('No row ID given!'));
	else $rowID = $_GET['rowid'];
}
switch ($_GET['action'])
{
	case 'delete':
		$result = sqlite::deleteRow($rowID, $tableName);
		common::redirect($_GET['redirect'], $result ? lang('Row deleted') : lang('Failed to delete row!'));
		break;
	case 'edit':
		$isUpdate = true;
		$isInsert = false;
		$DB = &database::singleton($_SESSION['database']['params']);
		sqlite::getUserFunctions();
		if (!empty($_POST))
		{
			list($sqlFields, $sqlValues) = parseRowData();
			foreach ($sqlFields as $k => $v) $sqlUpdates[] = "$v = $sqlValues[$k]";
			$sqlUpdates = implode(', ', $sqlUpdates);
			$sql = "UPDATE $tableName SET $sqlUpdates WHERE _ROWID_ = $rowID";
			$result = $DB->query($sql);
			$message = $result ? lang('Row updated') : lang('Failed to update row: ') . $DB->getLastError();
			if ($_POST['redirectType'] == 'return')
			{
               		$redirectTarget = !empty($_POST['redirect']) ? $_POST['redirect'] : "table.php?table=$tableName";
				common::redirect($redirectTarget, $message);
			}
			else if ($_POST['redirectType'] == 'insert')
			{
				$redirect = rawurlencode($_POST['redirect']);
				common::redirect("row.php?action=insert&table=$tableName&redirect=$redirect", $message);
			}
		}
		$tableStructure = sqlite::getTableStructure($tableName);
		$rowData = $DB->getRow("SELECT * FROM $tableName WHERE _ROWID_ = $rowID");
		$pageTitle = lang('Edit row');
		$submitLabel = lang('Update Row');
		$formAction = 'edit';
		break;
	case 'insert':
		$isUpdate = false;
		$isInsert = true;
		if (!empty($_POST))
		{
			$DB = &database::singleton($_SESSION['database']['params']);
			sqlite::getUserFunctions();
			$primaryKey = null;
			$autoIncrement = null;
			$tableStructure = sqlite::getTableStructure($tableName);
			foreach ($tableStructure as $column)
			{
				if ($column['pk']) $primaryKey = $column['name'];
				if ($column['autoincrement']) $autoIncrement = $column['name'];
			}
			$sqlFields = implode(', ', $sqlFields);
			$sqlValues = implode(', ', $sqlValues);
			$sql = "INSERT INTO $tableName ($sqlFields) VALUES($sqlValues)";
			$result = $DB->query($sql);
			$message = $result ? lang('Row inserted') : lang('Failed to insert row: ') . $DB->getLastError();
			if ($_POST['redirectType'] == 'return')
			{
               		$redirectTarget = !empty($_POST['redirect']) ? $_POST['redirect'] : "table.php?table=$tableName";
				common::redirect($redirectTarget, $message);
			}
			else if ($_POST['redirectType'] == 'insert')
			{
				$redirect = rawurlencode($_POST['redirect']);
				common::redirect("row.php?action=insert&table=$tableName&redirect=$redirect", $message);
			}
		}
		$tableStructure = sqlite::getTableStructure($tableName);
		foreach ($tableStructure as $t) $rowData[$t['name']] = $t['dflt_value'];
		$pageTitle = lang('Insert new row');
		$submitLabel = lang('Add Row');
		$formAction = 'insert';
		break;
	default:
		common::redirect("table.php?table=$tableName", lang('Unknown/no action given!'));
		break;
}
$userFunctions = sqlite::getUserFunctions();
$template = 'row.tpl';
include($config['base_dir'].'include/template.php');
?>