<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
include('conf.inc.php');
include($config['base_dir'].'include/prepend.php');
if (empty($_GET['table'])) common::redirect('database.php', lang('No table given!'));
else $tableName = $_GET['table'];
$DB = &database::singleton($_SESSION['database']['params']);
switch (@$_GET['action'])
{
	case 'addindex':
		if (!empty($_GET['column']) AND !empty($_GET['index']))
		{
			$index = $_GET['index'];
			$column = $_GET['column'];
			$unique = !empty($_GET['unique']) ? 'UNIQUE' : '';
			$result = $DB->query("CREATE $unique INDEX $index ON $tableName ($column)");
			$message = $result ? null : lang('Failed to create index, SQLite said: ') . $DB->getLastError();
			common::redirect("table.php?table=$tableName", $message);
		}
		else common::redirect("table.php?table=$tableName", lang('Column or index name missing - cannot create index'));
		break;
	case 'dropindex':
		if (!empty($_GET['index']))
		{
			$index   = $_GET['index'];
			$result  = $DB->query("DROP INDEX $index");
			$message = $result ? null : lang('Failed to create index, SQLite said: ') . $DB->getLastError();
			common::redirect("table.php?table=$tableName", $message);
		}
		else common::redirect("table.php?table=$tableName", lang('Index name missing - cannot drop index'));
		break;
	case 'empty':
		$result = $DB->query("DELETE FROM $tableName");
		$message = $result ? sprintf(lang('Table %s was emptied'), $tableName)  : lang('Failed to empty table!');
		$redirect = !empty($_GET['redirect']) ? $_GET['redirect'] : 'database.php';
		common::redirect($redirect, $message);
		break;
	case 'drop':
		$result = $DB->query("DROP TABLE $tableName");
		$message = $result ? sprintf(lang('Table %s was dropped'), $tableName) : 'Failed to empty table!';
		$redirect = !empty($_GET['redirect']) ? $redirect : 'database.php';
		common::redirect($redirect, $message);
		break;
	default:
		$structure = sqlite::getTableStructure($tableName);
		$rowCount = count($structure);
		$indexes = sqlite::getIndexList($tableName, true);
		break;
}
$template = 'table.tpl';
include($config['base_dir'].'include/template.php');
exit;
?>