<?php
/**
 phpSQLiteAdmin is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 phpSQLiteAdmin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with phpSQLiteAdmin; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
  Copyright 2004 Richard Heyes
  Copyright 2006-2007 Lexington Warner II <lex@fosilis.com>
*/
include('conf.inc.php');
include($config['base_dir'].'include/prepend.php');
if (empty($_GET['view'])) common::redirect('database.php', lang('No view name given!'));
else $viewName = $_GET['view'];
$DB = &database::singleton($_SESSION['database']['params']);
switch (@$_GET['action'])
{
	case 'editView':
		if (!empty($_POST))
		{
        		$DB = &database::singleton($_SESSION['database']['params']);
        		$result = $DB->query('BEGIN TRANSACTION');
			$result = $result AND sqlite::dropView($viewName);
			$result = $result AND sqlite::createView($_POST['viewName'], $_POST['viewSql'], !empty($_POST['viewTemporary']));
			if ($result)
			{
				$query = 'COMMIT TRANSACTION';
				$message = lang('View updated');
			}
			else
			{
				$query = 'ROLLBACK TRANSACTION';
				$message = sprintf(lang('Failed to update view, SQLite said: %s'), $DB->getLastError());
			}
			$DB->query($query);
			common::redirect('view.php?view=' . rawurlencode($_POST['viewName']), $message);
        	}
		else common::redirect('view.php?view=');
        	break;
	case 'drop':
		$message = sqlite::dropView($viewName) ? sprintf(lang('Dropped view <i>%s</i>'), $viewName) : lang('Failed to drop view, SQLite said: ') . $DB->getLastError();
		common::redirect('database.php');
        	break;
	case 'createView':
        	if (!empty($_POST))
		{
        		if (!empty($_POST['viewName']) AND !empty($_POST['viewSql']))
			{
				$result = sqlite::createView($_POST['viewName'], $_POST['viewSql'], !empty($_POST['viewTemporary']));
				if ($result)
				{
					$message = sprintf(lang('View <i>%s</i> created'), $_POST['viewName']);
					$redirect = 'view.php?view=' . sqlite::sanitiseIdentifier($_POST['viewName']);
				}
				else
				{
					$message = sprintf(lang('Failed to create view, SQLite said: %s'), $DB->getLastError());
					$redirect = 'view.php?view=null&action=createView';
				}
				common::redirect($redirect, $message);
        		}
			else common::redirect('view.php?action=createView&view=null', lang('Either name or SQL missing!'));
        	}
        	$pageTitle = lang('Create View');
		$formAction = 'createView';
		$submitValue = lang('Create View');
        	break;
	default:
		$showBrowse = true;
		$pageTitle = sprintf(lang('Properties for <i>%s</i>'), $viewName);
		$formAction = 'editView';
		$submitValue = lang('Save Changes');
		$viewProperties = sqlite::getViewProperties($viewName);
		break;
}
$template = 'view.tpl';
include($config['base_dir'].'include/template.php');
exit;
?>